<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width; initial-scale=1.0;"> 
  <title>Gym Mirror</title>
  <script src="//code.jquery.com/jquery-2.1.0.min.js"></script>
  <script>

  	// VARIABLES
  	// ------------------------------
  	var $viewName = 'view-center'; // only edit this
  	var $eventSource;
  	var $reps = 0;
  	var $set = 1;
  	var $checkinState = 0;
  	var $setStarted = 0;
	
  	// MAIN
  	// ------------------------------
  	$(function(){
		setup( eventListener );
  	});

  	// FUNCTIONS
  	// ------------------------------
  	
	function eventListener(){
		var evtSource = new EventSource( $eventSource );
		evtSource.onmessage = function(event) {
			console.log(event.data);
		
			var obj = JSON.parse(event.data);
			
			// COMMMAND LOGIC
			if( $checkinState == 0 ){
				if( obj.event == "checkin" ){
					runCommand("checkin");
				}
			}
			if( $checkinState == 1 ){
				if( obj.event == "checkout" ){
					runCommand("checkout");
				}
				if( obj.event == "set-start" && $setStarted == 0 ){
					runCommand("set-start");
				}
				if( obj.event == "set-end" && $setStarted == 1 ){
					runCommand("set-end");
				}
				if( obj.event == "reps-increment" && $setStarted == 1 ){
					runCommand("reps-increment");
				}			
			}
			
			// ADMIN CONTROLS
			if( obj.event == "reload" ){
				location.reload();
			}
			if( obj.event == "update-css" ){
				updateCSS();
			}
		};
	}
	
	function setup( callback ){
		updateCSS();
		runCommand("checkout");
		$.get( 'settings.json', function( settings ){
			$eventSource = settings[$viewName]['streamSource'];
			callback();
		});
	}
	
	// take actions
	function runCommand($cmd){
		switch( $cmd ){
			case "checkin":
				$('#main').fadeOut('slow', function() {
					$('#main').html("Hello James").fadeIn('slow',function(){
						$('#main').delay(2000).fadeOut('slow', function() {
							$('#main').html("Lift When Ready").fadeIn('slow');
						});
					});
				});
				
				$checkinState = 1;
				break;
			case "checkout":
				$('#main').fadeOut('slow', function() {
					$('#main').html("Machine Available").fadeIn('slow');
				});
				
				$checkinState = 0;
				break;
			case "set-start":
				$reps = 0;
							
				$('#main').fadeOut('slow', function() {
					$('#main').html("<p id='set'>Set " + $set + "</p><p id='reps'>" + $reps + "</p>").fadeIn('slow');
				});
				
				$setStarted = 1;
				break;
			case "set-end":
				$('#main').fadeOut('slow', function() {
					$('#main').html("Nice Set!").fadeIn('slow',function(){
						$('#main').delay(1000).fadeOut('slow', function() {
							$('#main').html("Lift When Ready").fadeIn('slow');
						});
					});
				});

				$reps = 0;
				$set++;
				$setStarted = 0;
				break;
			case "reps-increment":
				$reps++;
				$('#reps').html($reps);
				break;
		}
	}

  	// on the fly update of css
  	function updateCSS(){
		$.get( 'style.css', function( returnedCSS ){
			$('#styles').html( returnedCSS );
		});
  	}

  </script>
	<link rel="stylesheet" type="text/css" href="reset.css">
	<style id="styles"></style>
</head>
<body>

<div class="dead-center">
	<h1 id="main"></h1>
	<h1 id="set"></h1>
</div>

</body>
</html>