<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <title>Gym Mirror</title>
  <script src="//code.jquery.com/jquery-2.1.0.min.js"></script>
  <script>

  	//defaults
  	var $settingsObj;
  	var $reps = 0;
  	var $set = 1;
  	var $checkinState = 0;
  	var $setStarted = 0;
  
  	$(function(){
		setup();
  		eventListener();
  	});
  	
	function eventListener(){
		var evtSource = new EventSource("eventStream.php");
		evtSource.onmessage = function(event) {
			console.log(event.data);
		
			var obj = JSON.parse(event.data);
			// runCommand( obj.event );
			
			// COMMMAND LOGIC
			if( $checkinState == 0 ){
				if( obj.event == "checkin" ){
					runCommand("checkin");
				}
			}
			if( $checkinState == 1 ){
				if( obj.event == "checkout" ){
					runCommand("checkout");
				}
				if( obj.event == "set-start" && $setStarted == 0 ){
					runCommand("set-start");
				}
				if( obj.event == "set-end" && $setStarted == 1 ){
					runCommand("set-end");
				}
				if( obj.event == "reps-increment" && $setStarted == 1 ){
					runCommand("reps-increment");
				}			
			}
		};
	}
	
	function setup(){
		$.get( 'settings.json', function(settings){
// 			$settingsObj = settings;
// 			$checkinState = settings.options.checkinState;
// 			$setStarted = settings.options.setStarted;
						
			if( $checkinState == 0 ){
				runCommand("checkout");
			}
			if( $checkinState == 1 ){
				runCommand("checkin");
			}

		});
	}
	
	function runCommand($cmd){
		switch( $cmd ){
			case "checkin":
				$('#main').fadeOut('slow', function() {
					$('#main').html("Welcome back, James.").fadeIn('slow',function(){
						$('#main').delay(2000).fadeOut('slow', function() {
							$('#main').html("Lift when ready").fadeIn('slow');
						});
					});
					$('#profile').fadeOut('slow', function() {
						$('#profile').html("<p class='name'>James Lorem</p><p class='locker'>Locker #61</p>").fadeIn('slow');
					});
				});
				
				$checkinState = 1;
				break;
			case "checkout":
				$('#main').fadeOut('slow', function() {
					$('#main').html("Machine Available").fadeIn('slow');
				});
				$('#profile').fadeOut('slow');
				$('#sets').fadeOut('slow', function(){
					$('#sets').css("border-top","1px solid #000000");
					$('#sets').html("");
				});
				
				$checkinState = 0;
				break;
			case "set-start":
				$reps = 0;
							
				$('#main').fadeOut('slow', function() {
					$('#main').html("<p id='set'>Set " + $set + "</p><p id='reps'>" + $reps + "</p>").fadeIn('slow');
				});
				
				$setStarted = 1;
				break;
			case "set-end":
				// write to page
				$('#main').fadeOut('slow', function() {
					$('#main').html("Nice Set!").fadeIn('slow',function(){
						$('#main').delay(1000).fadeOut('slow', function() {
							$('#main').html("Lift when ready").fadeIn('slow');
						});
					});
				});

				$('#sets').append($("<li>Set "+$set+" : "+$reps+" reps @ 135 lbs</li>").hide().fadeIn('slow'));
				
				$('#sets').css("border-top","1px solid #ffffff");
				$('#sets').fadeIn('slow');
				// update counters
				$reps = 0;
				$set++;
				$setStarted = 0;
				break;
			case "reps-increment":
				$reps++;
				$('#reps').html($reps);
				break;
		}
	}

  </script>
	<link rel="stylesheet" type="text/css" href="reset.css">
	<style>
	body {
		background-color: #000000;
		color: #ffffff;
		font-family: "HelveticaNeue-Light", "Helvetica Neue Light", "Helvetica Neue", Helvetica, Arial, "Lucida Grande", sans-serif; 
		font-weight: 300;
	}
	.dead-center {
		position: fixed;
		top: 50%;
		left: 50%;
		width: 500px;
		height: 108px;
		margin-left: -250px;
		margin-top: -54px;
		z-index:1;	
	}

	h1 {
		text-align:center;
		font-size:xx-large;
	}
	#profile {
		margin: 50px 0 25px 50px;
	}
	#sets {
		display: inline-block;
		padding: 25px 0;
		margin: 0 50px;
	}	
	.name {
		font-size:x-large;
		margin-bottom:10px;
	}
	.locker {
		font-size:medium;
	}
	#main #set {
		font-size:large;
		margin-bottom:10px;
	}
	#main #reps {
		font-size:100px;
	}
	#sets {

	}
	#sets li {
		margin-bottom:15px;
	}
	</style>
</head>
<body>

<div class="dead-center">
	<h1 id="main"></h1>
	<h1 id="set"></h1>
</div>
<div id="profile"></div>
<ul id="sets"></ul>

</body>
</html>