<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width; initial-scale=1.0;"> 
  <title>Gym Mirror</title>
  <script src="//code.jquery.com/jquery-2.1.0.min.js"></script>
  <script>

  	// VARIABLES
  	// ------------------------------
  	var $viewName = 'view-top-left'; // only edit this
  	var $eventSource;
  	var $reps = 0;
  	var $set = 1;
  	var $checkinState = 0;
  	var $setStarted = 0;
	
  	// MAIN
  	// ------------------------------
  	$(function(){
		setup( eventListener );
  	});

  	// FUNCTIONS
  	// ------------------------------
  	
	function eventListener(){
		var evtSource = new EventSource( $eventSource );
		evtSource.onmessage = function(event) {
			console.log(event.data);
		
			var obj = JSON.parse(event.data);
			
			// COMMMAND LOGIC
			if( $checkinState == 0 ){
				if( obj.event == "checkin" ){
					runCommand("checkin");
				}
			}
			if( $checkinState == 1 ){
				if( obj.event == "checkout" ){
					runCommand("checkout");
				}
				if( obj.event == "set-start" && $setStarted == 0 ){
					runCommand("set-start");
				}
				if( obj.event == "set-end" && $setStarted == 1 ){
					runCommand("set-end");
				}
				if( obj.event == "reps-increment" && $setStarted == 1 ){
					runCommand("reps-increment");
				}			
			}
			
			// ADMIN CONTROLS
			if( obj.event == "reload" ){
				location.reload();
			}
			if( obj.event == "update-css" ){
				updateCSS();
			}
		};
	}
	
	function setup( callback ){
		updateCSS();
		runCommand("checkout");
		$.get( 'settings.json', function( settings ){
			$eventSource = settings[$viewName]['streamSource'];
			callback();
		});
	}
	
	// take actions
	function runCommand($cmd){
		switch( $cmd ){
			case "checkin":
				$('#profile').fadeOut('slow', function() {
					$('#profile').html("<p class='name'>James Maxfield</p><p class='locker'>Locker 23</p>").fadeIn('slow');
				});
				
				$checkinState = 1;
				break;
			case "checkout":
				$('#profile').fadeOut('slow');
				$('#sets').fadeOut('slow', function(){
					$('#sets').html("");
				});
				
				$checkinState = 0;
				break;
			case "set-start":
				$reps = 0;
				$setStarted = 1;
				break;
			case "set-end":
				$('#sets').append($("<li>Set "+$set+" : "+$reps+" reps, 135 lbs</li>").hide().fadeIn('slow'));
				$( "#sets" ).addClass( "line" );
				$('#sets').fadeIn('slow');

				$reps = 0;
				$set++;
				$setStarted = 0;
				break;
			case "reps-increment":
				$reps++;
				break;
		}
	}

  	// on the fly update of css
  	function updateCSS(){
		$.get( 'style.css', function( returnedCSS ){
			$('#styles').html( returnedCSS );
		});
  	}


  </script>
	<link rel="stylesheet" type="text/css" href="reset.css">
	<style id="styles"></style>
</head>
<body>

<div id="profile"></div>
<ul id="sets"></ul>

</body>
</html>